<?php

/**
 * Project: PSU - points system user (система баллов пользователя) <br />
 * File:    function.php
 * Description: Функции <br />
 *
 * @author Maxim Seshuk <maxim.seshuk@gmail.com>
 * @version P1 (update 2) (January 4th, 2012)
 * @last update 04.01.12 13:25
 *
 */

function API($url, $more)
{
    $context  = stream_context_create(array(
        'http' => array(
            'method' => "GET",
            'header' => "Content-Type: text/xml",
            'timeout' => 8
        )
    ));
    $file     = file_get_contents($url, false, $context);
    $response = xmlrpc_decode($file, "utf8");
    $response = str_replace(array(
        "i4>",
        "i8>"
    ), 'string>', $response);
    return $response[$more];
}
// Функция для использования API uCoz

function declOfNum($number, $titles)
{
    $cases = array(
        2,
        0,
        1,
        1,
        1,
        2
    );
    return $number . " " . $titles[($number % 100 > 4 && $number % 100 < 20) ? 2 : $cases[min($number % 10, 5)]];
}
//Функция для составления правильного окончания числительных

function Variables()
{
    global $variable;
    $args = func_get_args();
    if (empty($args[1]))
        return str_replace($variable[0], $variable[1], $args[0]);
    $count = count($args);
    for ($i = 0; $i < $count; $i = $i + 2) {
        $form = '$' . $args[$i] . '$';
        if (in_array($form, $variable[0])) {
            $search               = array_search($form, $variable[0]);
            $variable[0][$search] = $form;
            $variable[1][$search] = $args[$i + 1];
            continue;
        }
        $variable[0][] = $form;
        $variable[1][] = $args[$i + 1];
    }
}
// Переменные для плагинов

function uPSU($id)
{
    $cc     = new cURL();
    $result = $cc->get(SITE_ADDRESS . 'index/8-' . $id);
    preg_match_all('#<psu>(.*)<\/psu>#iSU', $result, $psu);
    return $psu[1][0];
    
}
// Вывод баллов с персональной страницы пользователя

function get_bool($value)
{
    switch (strtolower($value)) {
        case 'true':
            return true;
        case 'false':
            return false;
        default:
            return NULL;
    }
}
// Функция true или false (проверка)

function dir_list($d)
{
    foreach (array_diff(scandir($d), array(
        '.',
        '..'
    )) as $f)
        if (is_dir($d . '/' . $f))
            $l[] = $f;
    return $l;
}
// Функция вывода директорий

function amr()
{
    $r    = array();
    $args = func_get_args();
    foreach ($args as $a) {
        if (!is_array($a)) {
            $a = array(
                $a
            );
        }
        $r = array_merge_recursive($r, $a);
    }
    return $r;
}
// Объединения массивов

function getValue_input($html)
{
    foreach ($html->find('input') as $checkbox) {
        $type = $checkbox->getAttribute('type');
        if ($type == "checkbox") {
            $checked = $checkbox->getAttribute('checked');
            if ($checked) {
                $value        = $checkbox->value;
                $name         = $checkbox->name;
                $array[$name] = $value;
            }
        } else {
            $value        = $checkbox->value;
            $name         = $checkbox->name;
            $array[$name] = $value;
        }
    }
    return $array;
}
// Парсер input

function getValue_selected($html)
{
    foreach ($html->find('select') as $sel) {
        $selname = $sel->name;
        $opt     = $sel->find('option');
        foreach ($opt as $option) {
            if ($option->getAttribute('selected')) {
                $value           = $option->value;
                $array[$selname] = $value;
            }
        }
    }
    return $array;
}
// Парсер selected

class cURL
{
    var $headers;
    var $user_agent;
    var $compression;
    var $cookie_file;
    var $proxy;
    function cURL($headers = '', $cookies = TRUE, $cookie = 'cookies.txt', $compression = 'gzip', $proxy = '')
    {
        if ($this->headers) {
            $this->headers = $headers;
        } else {
            $this->headers[] = 'Accept: image/gif, image/x-bitmap, image/jpeg, image/pjpeg';
            $this->headers[] = 'Connection: Keep-Alive';
            $this->headers[] = 'Content-type: application/x-www-form-urlencoded;charset=UTF-8';
        }
        $this->user_agent  = 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 1.0.3705; .NET CLR 1.1.4322; Media Center PC 4.0)';
        $this->compression = $compression;
        $this->proxy       = $proxy;
        $this->cookies     = $cookies;
        if ($this->cookies == TRUE)
            $this->cookie($cookie);
    }
    function cookie($cookie_file)
    {
        if (file_exists($cookie_file)) {
            $this->cookie_file = $cookie_file;
        } else {
            fopen($cookie_file, 'w') or $this->error('The cookie file could not be opened. Make sure this directory has the correct permissions');
            $this->cookie_file = $cookie_file;
            fclose($this->cookie_file);
        }
    }
    function get($url)
    {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        curl_setopt($process, CURLOPT_HEADER, 0);
        curl_setopt($process, CURLOPT_USERAGENT, $this->user_agent);
        if ($this->cookies == TRUE)
            curl_setopt($process, CURLOPT_COOKIEFILE, $this->cookie_file);
        if ($this->cookies == TRUE)
            curl_setopt($process, CURLOPT_COOKIEJAR, $this->cookie_file);
        curl_setopt($process, CURLOPT_ENCODING, $this->compression);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy)
            curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }
    function post($url, $data)
    {
        $process = curl_init($url);
        curl_setopt($process, CURLOPT_HTTPHEADER, $this->headers);
        curl_setopt($process, CURLOPT_HEADER, 1);
        curl_setopt($process, CURLOPT_USERAGENT, $this->user_agent);
        if ($this->cookies == TRUE)
            curl_setopt($process, CURLOPT_COOKIEFILE, $this->cookie_file);
        if ($this->cookies == TRUE)
            curl_setopt($process, CURLOPT_COOKIEJAR, $this->cookie_file);
        curl_setopt($process, CURLOPT_ENCODING, $this->compression);
        curl_setopt($process, CURLOPT_TIMEOUT, 30);
        if ($this->proxy)
            curl_setopt($process, CURLOPT_PROXY, $this->proxy);
        curl_setopt($process, CURLOPT_POSTFIELDS, $data);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($process, CURLOPT_POST, 1);
        $return = curl_exec($process);
        curl_close($process);
        return $return;
    }
    function error($error)
    {
        echo "<center><div style='width:500px;border: 3px solid #FFEEFF; padding: 3px; background-color: #FFDDFF;font-family: verdana; font-size: 10px'><b>cURL Error</b><br>$error</div></center>";
        die;
    }
}

function generateRandStr($length)
{
    $randstr = "";
    for ($i = 0; $i < $length; $i++) {
        $randnum = mt_rand(0, 61);
        if ($randnum < 10) {
            $randstr .= chr($randnum + 48);
        } else if ($randnum < 36) {
            $randstr .= chr($randnum + 55);
        } else {
            $randstr .= chr($randnum + 61);
        }
    }
    return $randstr;
}
// Генерация текста