<?php

/**
 * Project: PSU - points system user (cистема баллов пользователя) <br />
 * File:    psu.class.php
 * Description: Класс<br />
 *
 * @author Maxim Seshuk <maxim.seshuk@gmail.com>
 * @version P1 (update 2) (January 4th, 2012)
 * @last update 04.01.12 13:25
 *
 */

class PSU
{
    var $points;
    /**
     * Переменная с количество баллов
     */
    
    var $file;
    /**
     * Переменная с названием файла базы данных
     */
    
    var $id;
    /**
     * Переменная с id пользователя, который мы передали
     */
    
    var $url;
    /**
     * Переменная с url
     */
    
    var $more1;
    /**
     * Доп. переменная
     */
    
    var $message;
    /**
     * Сообщение
     */
    
    var $operations;
    /**
     * Операция
     */
    
    private function uID()
    {
        return ucoz_getinfo("SITEUSERID");
    }
    /**
     * Функция вывода id пользователя на сайте
     */
    
    function Points($id = null, $number = null)
    {
        $file = file_get_contents($this->file);
        preg_match('#' . $id . '{points\=(.*)}#isU', $file, $content);
        return $content[$number];
    }
    /**
     * Функция вывода количества баллов пользователя
     */
    
    function Subtract()
    {
        $file    = file_get_contents($this->file);
        $minus   = $this->Points($this->id, 1) - $this->points;
        $handle  = fopen($this->file, 'w');
        $content = preg_replace('/' . $this->id . '{points=(.*)}/si', $this->id . '{points=' . $minus . '}', $file);
        if (fwrite($handle, $content)) {
            return 1;
        } else {
            return 0;
        }
        fclose($handle);
    }
    /**
     * Функция вычитания баллов
     */
    
    function Add()
    {
        $file    = file_get_contents($this->file);
        $minus   = $this->Points($this->id, 1) + $this->points;
        $handle  = fopen($this->file, 'w');
        $content = preg_replace('/' . $this->id . '{points=(.*)}/si', $this->id . '{points=' . $minus . '}', $file);
        if (fwrite($handle, $content)) {
            return 1;
        } else {
            return 0;
        }
        fclose($handle);
    }
    /**
     * Функция прибавления баллов
     */
    
    function Creation()
    {
        $handle  = fopen($this->file, 'a+');
        $content = "" . $this->id . "{points=$this->points},";
        if (fwrite($handle, $content)) {
            return 1;
        } else {
            return 0;
        }
        fclose($handle);
    }
    /**
     * Функция для создания строки пользователя в базе данных, если его там нет
     */
    
    private function GenerationID($file, $pattern)
    {
        while (true) {
            $mt_rand = mt_rand();
            if (!preg_match($pattern, $file)) {
                return $mt_rand;
                break;
            }
        }
    }
    /**
     * Функция для генерации уникального числа
     */
    
    function AddHistory($history_number = 10)
    {
        preg_match_all("#" . $this->id . "{(.*)}#isU", file_get_contents($this->file), $matches);
        if (count($matches[0]) >= $history_number) {
            $old         = $matches[0][0];
            $content_old = preg_replace('/' . $old . ',/si', '', file_get_contents($this->file));
            $handle_old  = fopen($this->file, 'w+');
            fwrite($handle_old, $content_old);
            fclose($handle_old);
            $handle  = fopen($this->file, 'a+');
            $content = "" . $this->id . "{number=" . $this->GenerationID($this->file, '#(.*){(.*)\,message\=' . $mt_rand . '\,(.*)\,(.*)}#isU') . ",message={$this->message},points={$this->points},timestamp=" . time() . ",operations={$this->operations}},";
            if (fwrite($handle, $content)) {
                return 1;
            } else {
                return 0;
            }
            fclose($handle);
        } else {
            $handle  = fopen($this->file, 'a+');
            $content = "" . $this->id . "{number=" . $this->GenerationID($this->file, '#(.*){(.*)\,message\=' . $mt_rand . '\,(.*)\,(.*)}#isU') . ",message={$this->message},points={$this->points},timestamp=" . time() . ",operations={$this->operations}},";
            if (fwrite($handle, $content)) {
                return 1;
            } else {
                return 0;
            }
            fclose($handle);
        }
    }
    /**
     * Запись операций
     */
    
    function ManyRequests($name = 'psu', $ban = 10)
    {
        session_start();
        $variable = 'time_' . $name;
        $time     = date('U');
        if (empty($_SESSION[$variable])) {
            $_SESSION[$variable] = $time;
            return true;
        }
        if (($_SESSION[$variable] + $ban - $time) <= 0) {
            unset($_SESSION[$variable]);
            return true;
        }
        return false;
    }
    /**
     * Создание сессии и записывание времемени в сессию
     * Помогает для того чтобы была небольшая нагрузка на сервер
     */
    
    function XML()
    {
        $xml = new SimpleXMLElement($this->file);
        return $xml;
    }
    /**
     * Создание элемента XML
     */
    
    function XMLScript()
    {
        $xml = new SimpleXMLElement($this->file);
        
        foreach ($xml->js->function as $key => $value) {
            $parameters = ($value->item[1]) ? $value->item[1] : '';
            echo "psu_{$this->more1}.{$value->item[0]} = function ($parameters) {{$value->item[2]}};" . "\n";
        }
    }
    /**
     * Функция обработки JS кодов плагинов
     */
}