JSON_URL = 'http://bank.smscoin.com/language/russian/json/bank/' + psu.sms_id;
first_countries = Array('RU', 'IL', 'UA');

function show(node) {
    node.style.display = '';
    return node;
}

function hide(node) {
    node.style.display = 'none';
    return node;
}

function update(node, text) {
    node.appendChild(document.createTextNode(text));
    return node;
}

function clear(node) {
    while (node.hasChildNodes()) {
        node.removeChild(node.firstChild);
    }
    return node;
}

function smscoin_id(id) {
    return document.getElementById(id)
}

function show_smscoin_id(id) {
    return show(smscoin_id(id))
}

function hide_smscoin_id(id) {
    return hide(smscoin_id(id))
}

function update_smscoin_id(id, text) {
    return update(smscoin_id(id), text)
}

function clear_smscoin_id(id) {
    return clear(smscoin_id(id))
}

function selectCost(cost) {
    document.getElementById('s_amount').value = cost / 1;
    if (cost) show_smscoin_id('sub');
    else hide_smscoin_id('sub');
}

function updateInstructions(json, data) {
    show_smscoin_id('instructions');
    show(clear_smscoin_id('select_cost'));
    hide_smscoin_id('sub');
    var select_cost = clear_smscoin_id('select_cost');
    var def = document.createElement('option');
    update(def, '-----').value = '-';
    select_cost.appendChild(def);
    for (var i = 0; i < json.length; ++i) {
        if (json[i].country_name == data.country_name && json[i].name == data.name) {
            var opt = document.createElement('option');
            update(opt, json[i].price + " " + json[i].currency + " " + (parseInt(json[i].vat) ? '(  )' : '(  )')).value = i;
            select_cost.appendChild(opt);
            if (json[i].special) show(update(clear_smscoin_id('notes'), json[i].special));
            else hide(clear_smscoin_id('notes'));
        }
    }
    select_cost.onchange = function () {
        var cost = this.value == '-' ? 0 : json[this.value].usd;
        selectCost(cost);
    }
}

function selectProvider(i, DATA) {
    hide_smscoin_id('sub');
    updateInstructions(DATA.providers, DATA.providers[i]);
}

function selectCountry(i) {
    if (JSONResponse[i].providers && JSONResponse[i].providers.length) {
        hide_smscoin_id('instructions');
        hide_smscoin_id('sub');
        show_smscoin_id('providers');
        DATA = JSONResponse[i];
        var select_provider = clear_smscoin_id('select_provider');
        var def = document.createElement('option');
        update(def, '-----').value = '-';
        var oldprovider = '';
        select_provider.appendChild(def);
        for (var j = 0; j < DATA.providers.length; ++j) {
            var opt = document.createElement('option');
            update(opt, DATA.providers[j].name).value = j;
            if (oldprovider != DATA.providers[j].name) select_provider.appendChild(opt);
            oldprovider = DATA.providers[j].name;
        }
        select_provider.onchange = function () {
            if (this.value == '-') {
                hide_smscoin_id('instructions');
                return;
            }
            document.getElementById('s_provider').value = DATA.providers[this.value].code;
            selectProvider(this.value, DATA);
        }
    } else {
        hide_smscoin_id('providers');
        hide_smscoin_id('sub');
        updateInstructions(JSONResponse, JSONResponse[i]);
    }
}

function JSONHandleResponse() {
    var n = 0;
    document.body.style.backgroundImage = 'none';
    if (!window.JSONResponse) {
        show_smscoin_id('fail');
        return;
    }
    for (var i = 0; i < JSONResponse.length; i++) {
        for (var c = 0; c < first_countries.length; c++)
        if (JSONResponse[i].country == first_countries[c]) n++;
    }
    for (var i = 0; i < (JSONResponse.length - 1); i++) {
        for (var j = (i + 1); j < JSONResponse.length; j++) {
            for (var c = first_countries.length - 1; c >= 0; c--) {
                if (JSONResponse[j].country == first_countries[c]) {
                    var temp = JSONResponse[i];
                    JSONResponse[i] = JSONResponse[j];
                    JSONResponse[j] = temp;
                }
            }
        }
    }
    for (var i = n; i < (JSONResponse.length - 1); i++) {
        for (var j = (i + 1); j < JSONResponse.length; j++) {
            if (JSONResponse[i].country_name > JSONResponse[j].country_name) {
                var temp = JSONResponse[i];
                JSONResponse[i] = JSONResponse[j];
                JSONResponse[j] = temp;
            }
        }
    }
    show_smscoin_id('ui');
    var select_country = smscoin_id('select_country');
    var oldcountry = '';
    for (var i = 0; i < JSONResponse.length; ++i) {
        var opt = document.createElement('option');
        update(opt, JSONResponse[i].country_name).value = i;
        if (oldcountry != JSONResponse[i].country_name) select_country.appendChild(opt);
        oldcountry = JSONResponse[i].country_name;
    }
    select_country.onchange = function () {
        if (this.value == '-') {
            hide_smscoin_id('providers');
            hide_smscoin_id('instructions');
            hide_smscoin_id('sub');
            return;
        }
        document.getElementById('s_country').value = JSONResponse[this.value].country;
        selectCountry(this.value);
    }
}

function JSONSendRequest() {
    var head_node = document.getElementsByTagName('head').item(0);
    var js_node = document.createElement('script');
    js_node.src = JSON_URL;
    js_node.type = 'text/javascript';
    js_node.charset = 'utf-8';
    if (navigator.product == 'Gecko') {
        js_node.onload = JSONHandleResponse;
    } else {
        js_node.onreadystatechange = function (evt) {
            evt ? 1 : evt = window.event;
            var rs = (evt.target || evt.srcElement).readyState;
            if (rs == 'loaded' || rs == 'complete') {
                JSONHandleResponse();
            }
        }
    }
    head_node.appendChild(js_node);
}

if (window.addEventListener) {
    window.addEventListener('load', JSONSendRequest, false);
} else if (window.attachEvent) {
    window.attachEvent('onload', JSONSendRequest);
}